<template>
  <div class="card item">
    <a
      class="badge badge-light m-0 p-0"
      href="#"
      data-trigger="hover"
      data-placement="auto"
      data-container="body"
      data-toggle="popover"
      :title="book.author"
      :data-content="book.title"
    >
      <img class="card-img-top p-0" :src="image(book.cover,book.covermimeType)" @click="showDetail(book)">
    </a>
    <div class="card-footer text-muted p-0 m-0">
      <div
        class="progress mb-1 mt-0 ml-0 mr-0"
        style="height: 5px;"
        data-trigger="hover"
        data-container="body"
        data-toggle="popover"
        :data-content="'Progress : '+progress+'%'"
      >
        <div
          class="progress-bar"
          :class="barColor"
          role="progressbar"
          :style="{width: progress+'%'}"
          :aria-valuenow="progress"
          aria-valuemin="0"
          aria-valuemax="100"
        ></div>
      </div>
      <div class="m-1 p-1 book">
        <div class="row">
          <div class=" col-9 d-flex flex-row align-items-center justify-content-space-bwtween" data-trigger="hover"  data-toggle="popover" data-content="Valoration">
            <template v-if="book.valoration">
              <font-awesome-icon v-for="key in book.valoration" :key="key"  color="goldenrod" icon="star"/>
            </template>
            <template v-else>
              <font-awesome-icon class="invisible" color="goldenrod" icon="star"/>
            </template>
          </div>
        </div>
        <div class="row align-items-center justify-content-center">
          <div class="col-4 btn book" data-trigger="hover" data-toggle="popover" data-content="Download" @click="donwload()">
              <font-awesome-icon icon="download" color="rgb(5, 5, 110)"/>
          </div>
          <div
            class="col-4 btn m-0 p-0 book"
            @click="readNow()"
            data-trigger="hover"
            data-toggle="popover"
            data-content="ReadNow"
          >
            <font-awesome-icon icon="book-reader" color="rgb(5, 5, 110)"/>
          </div>

          <div
            class="col-4 btn m-0 p-0 book"
            @click="$emit('toggleRead')"
            data-trigger="hover"
            data-toggle="popover"
            :data-content="isReaded"
          >
            <font-awesome-icon icon="eye" :color="readed"/>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>


<script>
const $ = require("jquery");
import toastr from "toastr";
import EventBus from '../../main';
export default {
  name: "book",
  components: {},
  props: [
    "book",
    "serverId",
    "progress"
    ],
   mounted:function(){
    $('[data-toggle="popover"]').popover();
   },
  created: function() {
    EventBus.$on("updateBookProgress"+this.book._id,progress=>{
      this.$emit("updateBookProgress",{bookId:this.book._id,progress:progress})
      this.updateBook(this.book._id,progress)
    })
  },

  data() {
    return {
      readingnow: false,
      token: localStorage.getItem("jwt"),
      user: JSON.parse(localStorage.getItem("user"))
    };
  },
  computed: {
    readed: function() {
      if (this.progress == 100) return "darkgreen";
      else return "darkgrey";
    },
    isReaded: function() {
      if (this.progress == 100) return "Readed";
      else return "NotReaded";
    },
    barColor: function() {
      if (this.progress < 25) return "bg-warning";
      else if (this.progress < 100) return "bg-info";
      else if (this.progress == 100) return "bg-success";
    }
  },
  methods: {
    image: (cover, mime) => {
      var bufer = new Buffer.from(cover);
      var imageToB64 = bufer.toString("base64");
      return "data:" + mime + ";base64, " + imageToB64;
    },
    showDetail(book) {
      $("body")
        .children()
        .popover("hide");
      this.$emit("bookDetail", book);
    },
    readNow() {
      EventBus.$emit('openBook',{
        require:{
          token: localStorage.getItem("jwt"),
          userId: this.user.id,
          bookPath: this.book.path,
          serverId: this.serverId,
          progress:this.progress,
        },
        book:this.book,
      })

    },
  donwload(){
    this.$socket.emit('reqBook',{
      token: localStorage.getItem("jwt"),
      userId: this.user.id,
      bookPath: this.book.path,
      serverId: this.serverId,
      fileName: this.book.title+' - '+this.book.author+'.epub',
      download: true
    })
  },

    updateBook(bookId,percent){
      //console.log(this.token+this.user.id+userId+serverId+percent)
      this.$socket.emit('reqSetReaded',{
          token:this.token,
          userId:this.user.id,
          bookId:bookId,
          serverId:this.serverId,
          percent:percent
      })
    }
  }
};
</script>

<style scoped>

.card.item {
  width: 100%;
  height: auto;
  display: flex;
  justify-content: space-between;
  flex-grow: initial;
}
.card-body,
.card-text {
  overflow-y: visible;
}
.card-text {
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
}

.card-footer {
  align-self: bottom;
}
@media (min-width: 576px) {
  .book{
    font-size: 1.5vh
  }
 }
@media (min-width: 768px) {
  .book{
    font-size: 1.5vh
  }
 }
@media (min-width: 992px) {
  .book{
    font-size: 3vh

  }
 }
@media (min-width: 1200px) {
  .book{
  font-size: 2vh
  }
 }

</style>
